Package ec.gp.koza

# Class CrossoverPipeline

java.lang.Object
ec.BreedingSource
ec.BreedingPipeline
ec.gp.GPBreedingPipeline
ec.gp.koza.CrossoverPipeline

All Implemented Interfaces:
  `Prototype`, `Setup`, `SteadyStateBSourceForm`, `RandomChoiceChooserD`, `Serializable`, `Cloneable`

public class CrossoverPipeline extends GPBreedingPipeline
CrossoverPipeline is a GPBreedingPipeline which performs a strongly-typed version of Koza-style "Subtree Crossover". Two individuals are selected, then a single tree is chosen in each such that the two trees have the same GPTreeConstraints. Then a random node is chosen in each tree such that each node's return type is type-compatible with the argument type of the slot in the parent which contains the other node. If by swapping subtrees at these nodes the two trees will not violate maximum depth constraints, then the trees perform the swap, otherwise, they repeat the hunt for random nodes.

The pipeline tries at most tries times to a pair of random nodes BOTH with valid swap constraints. If it cannot find any such pairs after tries times, it uses the pair of its last attempt. If either of the nodes in the pair is valid, that node gets substituted with the other node. Otherwise an individual invalid node isn't changed at all (it's "reproduced").

Compatibility with constraints. Since Koza-I/II only tries 1 time, and then follows this policy, this is compatible with Koza. lil-gp either tries 1 time, or tries forever. Either way, this is compatible with lil-gp. My hacked lil-gp kernel either tries 1 time, n times, or forever. This is compatible as well.

This pipeline typically produces up to 2 new individuals (the two newly- swapped individuals) per produce(...) call. If the system only needs a single individual, the pipeline will throw one of the new individuals away. The user can also have the pipeline always throw away the second new individual instead of adding it to the population. In this case, the pipeline will only typically produce 1 new individual per produce(...) call.

Typical Number of Individuals Produced Per `produce(...)` call
2 * minimum typical number of individuals produced by each source, unless tossSecondParent is set, in which case it's simply the minimum typical number.

Number of Sources
2

Parameters

base.`tries` int >= 1 | (number of times to try finding valid pairs of nodes)
base.`maxdepth` int >= 1 | (maximum valid depth of a crossed-over subtree)
base.`maxsize` int >= 1 | (maximum valid size, in nodes, of a crossed-over subtree)
base.`tree.0` 0 < int < (num trees in individuals), if exists | (first tree for the crossover; if parameter doesn't exist, tree is picked at random)
base.`tree.1` 0 < int < (num trees in individuals), if exists | (second tree for the crossover; if parameter doesn't exist, tree is picked at random. This tree must have the same GPTreeConstraints as `tree.0`, if `tree.0` is defined.)
base.`ns.`n classname, inherits and != GPNodeSelector, or String `same``` | (GPNodeSelector for parent n (n is 0 or 1) If, for `ns.1` the value is `same`, then `ns.1` a copy of whatever `ns.0` is. Note that the default version has no n)
base.`toss` bool = `true` or `false` (default)/td> | (after crossing over with the first new individual, should its second sibling individual be thrown away instead of adding it to the population?)

Default Base
gp.koza.xover

Parameter bases

base.`ns.`n | nodeselectn (n is 0 or 1)

See Also:
  - Serialized Form

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final int`
  `INDS_PRODUCED`
  `static final String`
  `KEY_PARENTS`
  `int`
  `maxDepth`
  The deepest tree the pipeline is allowed to form.
  `int`
  `maxSize`
  The largest tree (measured as a nodecount) the pipeline is allowed to form.
  `static final int`
  `NO_SIZE_LIMIT`
  `GPNodeSelector`
  `nodeselect1`
  How the pipeline selects a node from individual 1
  `GPNodeSelector`
  `nodeselect2`
  How the pipeline selects a node from individual 2
  `static final int`
  `NUM_SOURCES`
  `int`
  `numTries`
  How many times the pipeline attempts to pick nodes until it gives up.
  `static final String`
  `P_CROSSOVER`
  `static final String`
  `P_MAXDEPTH`
  `static final String`
  `P_MAXSIZE`
  `static final String`
  `P_NUM_TRIES`
  `static final String`
  `P_TOSS`
  `ArrayList<Individual>`
  `parents`
  Temporary holding place for parents
  `boolean`
  `tossSecondParent`
  Should the pipeline discard the second parent after crossing over?
  `int`
  `tree1`
  Is the first tree fixed? If not, this is -1
  `int`
  `tree2`
  Is the second tree fixed? If not, this is -1

  ### Fields inherited from class ec.gp.GPBreedingPipeline

  `P_NODESELECTOR, P_TREE, TREE_UNFIXED`

  ### Fields inherited from class ec.BreedingPipeline

  `DYNAMIC_SOURCES, likelihood, mybase, P_LIKELIHOOD, P_NUMSOURCES, P_SOURCE, sources, V_SAME, V_STUB`

  ### Fields inherited from class ec.BreedingSource

  `NO_PROBABILITY, P_PROB, probability`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `CrossoverPipeline()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Object`
  `clone()`
  Creates a new individual cloned from a prototype, and suitable to begin use in its own evolutionary context.
  `Parameter`
  `defaultBase()`
  Returns the default base for this prototype.
  `int`
  `numSources()`
  Returns the number of sources to this pipeline.
  `int`
  `produce(int min, int max, int subpopulation, ArrayList<Individual> inds, EvolutionState state, int thread, HashMap<String,Object> misc)`
  Produces n individuals from the given subpopulation and puts them into inds[start...start+n-1], where n = Min(Max(q,min),max), where q is the "typical" number of individuals the BreedingSource produces in one shot, and returns n.
  `void`
  `setup(EvolutionState state, Parameter base)`
  Sets up the BreedingPipeline.
  `int`
  `typicalIndsProduced()`
  Returns 2 * minimum number of typical individuals produced by any sources, else 1* minimum number if tossSecondParent is true.
  `boolean`
  `verifyPoints(GPInitializer initializer, GPNode inner1, GPNode inner2)`
  Returns true if inner1 can feasibly be swapped into inner2's position.

  ### Methods inherited from class ec.gp.GPBreedingPipeline

  `produces`

  ### Methods inherited from class ec.BreedingPipeline

  `fillStubs, finishProducing, individualReplaced, maxChildProduction, minChildProduction, preparePipeline, prepareToProduce, sourcesAreProperForm`

  ### Methods inherited from class ec.BreedingSource

  `getProbability, pickRandom, setProbability, setupProbabilities`

  ### Methods inherited from class java.lang.Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### P_NUM_TRIES

    public static final String P_NUM_TRIES
    See Also:
      - Constant Field Values

  - ### P_MAXDEPTH

    public static final String P_MAXDEPTH
    See Also:
      - Constant Field Values

  - ### P_MAXSIZE

    public static final String P_MAXSIZE
    See Also:
      - Constant Field Values

  - ### P_CROSSOVER

    public static final String P_CROSSOVER
    See Also:
      - Constant Field Values

  - ### P_TOSS

    public static final String P_TOSS
    See Also:
      - Constant Field Values

  - ### INDS_PRODUCED

    public static final int INDS_PRODUCED
    See Also:
      - Constant Field Values

  - ### NUM_SOURCES

    public static final int NUM_SOURCES
    See Also:
      - Constant Field Values

  - ### NO_SIZE_LIMIT

    public static final int NO_SIZE_LIMIT
    See Also:
      - Constant Field Values

  - ### KEY_PARENTS

    public static final String KEY_PARENTS
    See Also:
      - Constant Field Values

  - ### nodeselect1

    public GPNodeSelector nodeselect1
    How the pipeline selects a node from individual 1

  - ### nodeselect2

    public GPNodeSelector nodeselect2
    How the pipeline selects a node from individual 2

  - ### tree1

    public int tree1
    Is the first tree fixed? If not, this is -1

  - ### tree2

    public int tree2
    Is the second tree fixed? If not, this is -1

  - ### numTries

    public int numTries
    How many times the pipeline attempts to pick nodes until it gives up.

  - ### maxDepth

    public int maxDepth
    The deepest tree the pipeline is allowed to form. Single terminal trees are depth 1.

  - ### maxSize

    public int maxSize
    The largest tree (measured as a nodecount) the pipeline is allowed to form.

  - ### tossSecondParent

    public boolean tossSecondParent
    Should the pipeline discard the second parent after crossing over?

  - ### parents

    public ArrayList<Individual> parents
    Temporary holding place for parents

- ## Constructor Details

  - ### CrossoverPipeline

    public CrossoverPipeline()

- ## Method Details

  - ### defaultBase

    public Parameter defaultBase()
    Description copied from interface: `Prototype`
    Returns the default base for this prototype. This should generally be implemented by building off of the static base() method on the DefaultsForm object for the prototype's package. This should be callable during setup(...).

  - ### numSources

    public int numSources()
    Description copied from class: `BreedingPipeline`
    Returns the number of sources to this pipeline. Called during BreedingPipeline's setup. Be sure to return a value > 0, or DYNAMIC_SOURCES which indicates that setup should check the parameter file for the parameter "num-sources" to make its determination.
    Specified by:
      `numSources` in class `BreedingPipeline`

  - ### clone

    public Object clone()
    Description copied from interface: `Prototype`
    Creates a new individual cloned from a prototype, and suitable to begin use in its own evolutionary context.

    Typically this should be a full "deep" clone. However, you may share certain elements with other objects rather than clone hem, depending on the situation:

    - If you hold objects which are shared with other instances, don't clone them.
    - If you hold objects which must be unique, clone them.
    - If you hold objects which were given to you as a gesture of kindness, and aren't owned by you, you probably shouldn't clone them.
    - DON'T attempt to clone: Singletons, Cliques, or Populations, or Subpopulation.
    - Arrays are not cloned automatically; you may need to clone an array if you're not sharing it with other instances. Arrays have the nice feature of being copyable by calling clone() on them.

    Implementations.

    - If no ancestor of yours implements clone(), and you have no need to do clone deeply, and you are abstract, then you should not declare clone().
    - If no ancestor of yours implements clone(), and you have no need to do clone deeply, and you are not abstract, then you should implement it as follows:

      ``

           public Object clone()
               {
               try
                   {
                   return super.clone();
                   }
               catch ((CloneNotSupportedException e)
                   { throw new InternalError(); } // never happens
               }

    - If no ancestor of yours implements clone(), but you need to deep-clone some things, then you should implement it as follows:

      ``

           public Object clone()
               {
               try
                   {
                   MyObject myobj = (MyObject) (super.clone());

                   // put your deep-cloning code here...
                   }
               catch ((CloneNotSupportedException e)
                   { throw new InternalError(); } // never happens
               return myobj;
               }

    - If an ancestor has implemented clone(), and you also need to deep clone some things, then you should implement it as follows:

      ``

           public Object clone()
               {
               MyObject myobj = (MyObject) (super.clone());

               // put your deep-cloning code here...

               return myobj;
               }

    Specified by:
      `clone` in interface `Prototype`
    Overrides:
      `clone` in class `BreedingPipeline`

  - ### setup

    public void setup(EvolutionState state, Parameter base)
    Description copied from class: `BreedingSource`
    Sets up the BreedingPipeline. You can use state.output.error here because the top-level caller promises to call exitIfErrors() after calling setup. Note that probability might get modified again by an external source if it doesn't normalize right.

    The most common modification is to normalize it with some other set of probabilities, then set all of them up in increasing summation; this allows the use of the fast static BreedingSource-picking utility method, BreedingSource.pickRandom(...). In order to use this method, for example, if four breeding source probabilities are {0.3, 0.2, 0.1, 0.4}, then they should get normalized and summed by the outside owners as: {0.3, 0.5, 0.6, 1.0}.

    Specified by:
      `setup` in interface `Prototype`
    Specified by:
      `setup` in interface `Setup`
    Overrides:
      `setup` in class `BreedingPipeline`
    See Also:
      - `Prototype.setup(EvolutionState,Parameter)`

  - ### typicalIndsProduced

    public int typicalIndsProduced()
    Returns 2 * minimum number of typical individuals produced by any sources, else 1* minimum number if tossSecondParent is true.
    Overrides:
      `typicalIndsProduced` in class `BreedingPipeline`

  - ### verifyPoints

    public boolean verifyPoints(GPInitializer initializer, GPNode inner1, GPNode inner2)
    Returns true if inner1 can feasibly be swapped into inner2's position.

  - ### produce

    public int produce(int min, int max, int subpopulation, ArrayList<Individual> inds, EvolutionState state, int thread, HashMap<String,Object> misc)
    Description copied from class: `BreedingSource`
    Produces n individuals from the given subpopulation and puts them into inds[start...start+n-1], where n = Min(Max(q,min),max), where q is the "typical" number of individuals the BreedingSource produces in one shot, and returns n. max must be >= min, and min must be >= 1. For example, crossover might typically produce two individuals, tournament selection might typically produce a single individual, etc.
    Specified by:
      `produce` in class `BreedingSource`